#include <stdio.h>
#include <string.h>

#ifndef __MD6502_H__
#define __MD6502_H__

typedef unsigned char	uchar;
typedef unsigned short	ushort;
typedef unsigned int	uint;
typedef unsigned long	ulong;




typedef struct _reg6502 {
	uchar a;
	uchar x;
	uchar y;
	union {
		uchar sr;
		struct {
			uchar carry : 1;
			uchar zero : 1;
			uchar intr : 1;
			uchar dec : 1;
			uchar brk : 1;
			uchar resv : 1;
			uchar ovfl : 1;
			uchar sign : 1;
		};
	} sr;
	ushort sp;
	ushort pc;
} reg6502;


//y[W0FŃAhXi8000~BFFF̂Ƃ́Ay[W̏	//2015.3.24
typedef struct _label0f {
	uchar page;
	ushort staddr;
	ushort edaddr;
} label0f;

//BRK ̍sAhX				//2013.6.13
typedef struct _addrbrk {
	ushort addr;
	uchar page;
} addrbrk;

//0x8000ȍ~̃x				//2012.10.20
typedef struct _proglabel {
	ushort addr;
	uchar page;
	char *comment;
} proglabel;

//IvṼx
typedef struct _optionlabel {
	uchar page;
	ushort staddr;
	ushort edaddr;
	uchar unit;
	char *comment;
} optionlabel;


typedef struct _memargstr {
	ushort staddr;				// JnAhX
	ushort edaddr;				// IAhX
	int access;					// ANZX@̃tO
	char *comment;				// Rg̓e
} memargstr;


// ԂĺAXe[g
typedef int (*op6502)(reg6502 *);



typedef struct {
	char *nimonic;
	int type;
//	op6502 func;
} dis6502str;

// dis6502str.type = Address Type | Access Type;
// Address Type
enum {
	ADT_NONE = 0,
	ADT_IMM,				// l
	ADT_AREG,				// A Register
	ADT_ZEROP,				// Zero Page
	ADT_ZEROPX,				// Zero Page,X
	ADT_ZEROPY,				// Zero Page,Y
	ADT_REL,				// ΃AhX
	ADT_ABS,				// ΃AhX
	ADT_ABSX,				// ΃AhX,X
	ADT_ABSY,				// ΃AhX,Y
	ADT_ABSIND,				// Ԑڐ΃AhX
	ADT_PREIND,				// OuԐ (Zero Page,X)
	ADT_POSTIND,			// uԐ (Zero Page),Y
};

#define ADT_MASK 0xff

// Access Type
enum {
	ACT_NL = 0x000,
	ACT_RD = 0x100,
	ACT_WT = 0x200,
	ACT_WD = 0x400,			// for DataAccess
};

#define ACT_MASK ( ACT_RD | ACT_WT )


// Name Type
enum {
	NMT_UND = 0,
	NMT_ADC,
	NMT_AND,
	NMT_ASL,
	NMT_BCC,
	NMT_BCS,
	NMT_BEQ,
	NMT_BIT,
	NMT_BMI,
	NMT_BNE,
	NMT_BPL,
	NMT_BRK,
	NMT_BVC,
	NMT_BVS,
	NMT_CLC,
	NMT_CLD,
	NMT_CLI,
	NMT_CLV,
	NMT_CMP,
	NMT_CPX,
	NMT_CPY,
	NMT_DEC,
	NMT_DEX,
	NMT_DEY,
	NMT_EOR,
	NMT_INC,
	NMT_INX,
	NMT_INY,
	NMT_JMP,
	NMT_JSR,
	NMT_LDA,
	NMT_LDX,
	NMT_LDY,
	NMT_LSR,
	NMT_NOP,
	NMT_ORA,
	NMT_PHA,
	NMT_PHP,
	NMT_PLA,
	NMT_PLP,
	NMT_ROL,
	NMT_ROR,
	NMT_RTI,
	NMT_RTS,
	NMT_SBC,
	NMT_SEC,
	NMT_SED,
	NMT_SEI,
	NMT_STA,
	NMT_STX,
	NMT_STY,
	NMT_TAX,
	NMT_TAY,
	NMT_TSX,
	NMT_TXA,
	NMT_TXS,
	NMT_TYA,
};



op6502 undefop(void) { return 0;}

char *adtstring[] = {
(char*)	"\t\t",				// 0
(char*)	"#$%02X\t\t",			// 1
(char*)	"a\t\t",			// 2
(char*)	"$%02X\t\t",			// 3

(char*)	"$%02X,x\t\t",			// 4
(char*)	"$%02X,y\t\t",			// 5
(char*)	"$%04X\t\t",			// 6
(char*)	"$%04X\t\t",			// 7

(char*)	"$%04X,x\t\t",			// 8
(char*)	"$%04X,y\t\t",			// 9
(char*)	"($%04X)\t\t",			//10
(char*)	"($%02X,x)\t\t",		//11

(char*)	"($%02X),y\t\t",		//12
(char*)	"$%02X,$%02X,$%02X\t",		//13
(char*)	"($%04X,$%02X)\t",		//14
(char*) "($%04X,$%02X)\t",		//15

(char*) "($%04X,$%02X)\t",		//16
(char*)	"$%04X\t\t",			//17
};

int opbytelength[] = {	// 0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17			//14.7.22	//14.9.24
			   1, 2, 1, 2, 2, 2, 2, 3, 3, 3, 3, 2, 2, 4, 3, 4, 5, 4		};

char *opname[] = {
(char*)	"db",  (char*)	"adc", (char*)	"and", (char*)	"asl", (char*)	"bcc", (char*)	"bcs", (char*)	"beq", (char*)	"bit",
(char*)	"bmi", (char*)	"bne", (char*)	"bpl", (char*)	"brk", (char*)	"bvc", (char*)	"bvs", (char*)	"clc", (char*)	"cld",
(char*)	"cli", (char*)	"clv", (char*)	"cmp", (char*)	"cpx", (char*)	"cpy", (char*)	"dec", (char*)	"dex", (char*)	"dey",
(char*)	"eor", (char*)	"inc", (char*)	"inx", (char*)	"iny", (char*)	"jmp", (char*)	"jsr", (char*)	"lda", (char*)	"ldx",
(char*)	"ldy", (char*)	"lsr", (char*)	"nop", (char*)	"ora", (char*)	"pha", (char*)	"php", (char*)	"pla", (char*)	"plp",
(char*)	"rol", (char*)	"ror", (char*)	"rti", (char*)	"rts", (char*)	"sbc", (char*)	"sec", (char*)	"sed", (char*)	"sei",
(char*)	"sta", (char*)	"stx", (char*)	"sty", (char*)	"tax", (char*)	"tay", (char*)	"tsx", (char*)	"txa", (char*)	"txs",
(char*)	"tya"
};

// tÔŖĂFJSR , RTS , RTI ́AꉞX^bNɑ΂ēǂݏ
// sĂ邩A{Ȃ RD,WT ͂ǁA NL ɂB
// FJMP (ADDR) ˁBꉞ NL ɂĂ
// ɈFPHx,PLx  RD,WT ɂĂBǂX^bN삵Ȃ̂A
// JSRƂƓɂׂȂH

dis6502str dis6502[256] = {
	// 00-0F
	{ opname[NMT_BRK],ACT_RD | ADT_ABS },			//2012.10.17
	{ opname[NMT_ORA],ACT_RD | ADT_PREIND },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_ORA],ACT_RD | ADT_ZEROP },
	{ opname[NMT_ASL],ACT_WT | ADT_ZEROP },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_PHP],ACT_WT | ADT_NONE },
	{ opname[NMT_ORA],ACT_NL | ADT_IMM },
	{ opname[NMT_ASL],ACT_NL | ADT_AREG },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_ORA],ACT_RD | ADT_ABS },
	{ opname[NMT_ASL],ACT_WT | ADT_ABS },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	// 10-1F
	{ opname[NMT_BPL],ACT_NL | ADT_REL },
	{ opname[NMT_ORA],ACT_RD | ADT_POSTIND },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_ORA],ACT_RD | ADT_ZEROPX },
	{ opname[NMT_ASL],ACT_WT | ADT_ZEROPX },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_CLC],ACT_NL | ADT_NONE },
	{ opname[NMT_ORA],ACT_RD | ADT_ABSY },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_ORA],ACT_RD | ADT_ABSX },
	{ opname[NMT_ASL],ACT_WT | ADT_ABSX },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	// 20-2F
	{ opname[NMT_JSR],ACT_NL | ADT_ABS },
	{ opname[NMT_AND],ACT_RD | ADT_PREIND },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_BIT],ACT_RD | ADT_ZEROP },
	{ opname[NMT_AND],ACT_RD | ADT_ZEROP },
	{ opname[NMT_ROL],ACT_WT | ADT_ZEROP },
	{ opname[NMT_UND],ACT_RD | ADT_NONE },
	{ opname[NMT_PLP],ACT_RD | ADT_NONE },
	{ opname[NMT_AND],ACT_RD | ADT_IMM },
	{ opname[NMT_ROL],ACT_NL | ADT_AREG },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_BIT],ACT_RD | ADT_ABS },
	{ opname[NMT_AND],ACT_RD | ADT_ABS },
	{ opname[NMT_ROL],ACT_WT | ADT_ABS },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	// 30-3F
	{ opname[NMT_BMI],ACT_NL | ADT_REL },
	{ opname[NMT_AND],ACT_RD | ADT_POSTIND },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_AND],ACT_RD | ADT_ZEROPX },
	{ opname[NMT_ROL],ACT_WT | ADT_ZEROPX },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_SEC],ACT_NL | ADT_NONE },
	{ opname[NMT_AND],ACT_RD | ADT_ABSY },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_AND],ACT_RD | ADT_ABSX },
	{ opname[NMT_ROL],ACT_WT | ADT_ABSX },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	// 40-4F
	{ opname[NMT_RTI],ACT_NL | ADT_NONE },
	{ opname[NMT_EOR],ACT_RD | ADT_PREIND },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_EOR],ACT_RD | ADT_ZEROP },
	{ opname[NMT_LSR],ACT_WT | ADT_ZEROP },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_PHA],ACT_WT | ADT_NONE },
	{ opname[NMT_EOR],ACT_NL | ADT_IMM },
	{ opname[NMT_LSR],ACT_NL | ADT_AREG },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_JMP],ACT_NL | ADT_ABS },
	{ opname[NMT_EOR],ACT_RD | ADT_ABS },
	{ opname[NMT_LSR],ACT_WT | ADT_ABS },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	// 50-5F
	{ opname[NMT_BVC],ACT_NL | ADT_REL },
	{ opname[NMT_EOR],ACT_RD | ADT_POSTIND },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_EOR],ACT_RD | ADT_ZEROPX },
	{ opname[NMT_LSR],ACT_WT | ADT_ZEROPX },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_CLI],ACT_NL | ADT_NONE },
	{ opname[NMT_EOR],ACT_RD | ADT_ABSY },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_EOR],ACT_RD | ADT_ABSX },
	{ opname[NMT_LSR],ACT_WT | ADT_ABSX },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	// 60-6F
	{ opname[NMT_RTS],ACT_NL | ADT_NONE },
	{ opname[NMT_ADC],ACT_RD | ADT_PREIND },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_ADC],ACT_RD | ADT_ZEROP },
	{ opname[NMT_ROR],ACT_WT | ADT_ZEROP },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_PLA],ACT_RD | ADT_NONE },
	{ opname[NMT_ADC],ACT_NL | ADT_IMM },
	{ opname[NMT_ROR],ACT_NL | ADT_AREG },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_JMP],ACT_NL | ADT_ABSIND },
	{ opname[NMT_ADC],ACT_RD | ADT_ABS },
	{ opname[NMT_ROR],ACT_WT | ADT_ABS },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	// 70-7F
	{ opname[NMT_BVS],ACT_NL | ADT_REL },
	{ opname[NMT_ADC],ACT_RD | ADT_POSTIND },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_ADC],ACT_RD | ADT_ZEROPX },
	{ opname[NMT_ROR],ACT_WT | ADT_ZEROPX },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_SEI],ACT_NL | ADT_NONE },
	{ opname[NMT_ADC],ACT_RD | ADT_ABSY },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_ADC],ACT_RD | ADT_ABSX },
	{ opname[NMT_ROR],ACT_WT | ADT_ABSX },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	// 80-8F
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_STA],ACT_WT | ADT_PREIND },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_STY],ACT_WT | ADT_ZEROP },
	{ opname[NMT_STA],ACT_WT | ADT_ZEROP },
	{ opname[NMT_STX],ACT_WT | ADT_ZEROP },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_DEY],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_TXA],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_STY],ACT_WT | ADT_ABS },
	{ opname[NMT_STA],ACT_WT | ADT_ABS },
	{ opname[NMT_STX],ACT_WT | ADT_ABS },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	// 90-9F
	{ opname[NMT_BCC],ACT_NL | ADT_REL },
	{ opname[NMT_STA],ACT_WT | ADT_POSTIND },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_STY],ACT_WT | ADT_ZEROPX },
	{ opname[NMT_STA],ACT_WT | ADT_ZEROPX },
	{ opname[NMT_STX],ACT_WT | ADT_ZEROPY },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_TYA],ACT_NL | ADT_NONE },
	{ opname[NMT_STA],ACT_WT | ADT_ABSY },
	{ opname[NMT_TXS],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_STA],ACT_WT | ADT_ABSX },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	// A0-AF
	{ opname[NMT_LDY],ACT_NL | ADT_IMM },
	{ opname[NMT_LDA],ACT_RD | ADT_PREIND },
	{ opname[NMT_LDX],ACT_NL | ADT_IMM },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_LDY],ACT_RD | ADT_ZEROP },
	{ opname[NMT_LDA],ACT_RD | ADT_ZEROP },
	{ opname[NMT_LDX],ACT_RD | ADT_ZEROP },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_TAY],ACT_NL | ADT_NONE },
	{ opname[NMT_LDA],ACT_NL | ADT_IMM },
	{ opname[NMT_TAX],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_LDY],ACT_RD | ADT_ABS },
	{ opname[NMT_LDA],ACT_RD | ADT_ABS },
	{ opname[NMT_LDX],ACT_RD | ADT_ABS },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	// B0-BF
	{ opname[NMT_BCS],ACT_NL | ADT_REL },
	{ opname[NMT_LDA],ACT_RD | ADT_POSTIND },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_LDY],ACT_RD | ADT_ZEROPX },
	{ opname[NMT_LDA],ACT_RD | ADT_ZEROPX },
	{ opname[NMT_LDX],ACT_RD | ADT_ZEROPY },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_CLV],ACT_NL | ADT_NONE },
	{ opname[NMT_LDA],ACT_RD | ADT_ABSY },
	{ opname[NMT_TSX],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_LDY],ACT_RD | ADT_ABSX },
	{ opname[NMT_LDA],ACT_RD | ADT_ABSX },
	{ opname[NMT_LDX],ACT_RD | ADT_ABSY },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	// C0-CF
	{ opname[NMT_CPY],ACT_NL | ADT_IMM },
	{ opname[NMT_CMP],ACT_RD | ADT_PREIND },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_CPY],ACT_RD | ADT_ZEROP },
	{ opname[NMT_CMP],ACT_RD | ADT_ZEROP },
	{ opname[NMT_DEC],ACT_WT | ADT_ZEROP },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_INY],ACT_NL | ADT_NONE },
	{ opname[NMT_CMP],ACT_NL | ADT_IMM },
	{ opname[NMT_DEX],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_CPY],ACT_RD | ADT_ABS },
	{ opname[NMT_CMP],ACT_RD | ADT_ABS },
	{ opname[NMT_DEC],ACT_WT | ADT_ABS },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	// D0-DF
	{ opname[NMT_BNE],ACT_NL | ADT_REL },
	{ opname[NMT_CMP],ACT_RD | ADT_POSTIND },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_CMP],ACT_RD | ADT_ZEROPX },
	{ opname[NMT_DEC],ACT_WT | ADT_ZEROPX }, /* AADT_ZEROPY  X ֏C */
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_CLD],ACT_NL | ADT_NONE },
	{ opname[NMT_CMP],ACT_RD | ADT_ABSY },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_CMP],ACT_RD | ADT_ABSX },
	{ opname[NMT_DEC],ACT_WT | ADT_ABSX },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	// E0-EF
	{ opname[NMT_CPX],ACT_NL | ADT_IMM },
	{ opname[NMT_SBC],ACT_RD | ADT_PREIND },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_CPX],ACT_RD | ADT_ZEROP },
	{ opname[NMT_SBC],ACT_RD | ADT_ZEROP },
	{ opname[NMT_INC],ACT_WT | ADT_ZEROP },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_INX],ACT_NL | ADT_NONE },
	{ opname[NMT_SBC],ACT_NL | ADT_IMM },
	{ opname[NMT_NOP],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_CPX],ACT_RD | ADT_ABS },
	{ opname[NMT_SBC],ACT_RD | ADT_ABS },
	{ opname[NMT_INC],ACT_WT | ADT_ABS },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	// F0-FF
	{ opname[NMT_BEQ],ACT_NL | ADT_REL },
	{ opname[NMT_SBC],ACT_RD | ADT_POSTIND },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_SBC],ACT_RD | ADT_ZEROPX },
	{ opname[NMT_INC],ACT_WT | ADT_ZEROPX },/* Zeropx -> y ɏC */
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_SED],ACT_NL | ADT_NONE },
	{ opname[NMT_SBC],ACT_RD | ADT_ABSY },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_UND],ACT_NL | ADT_NONE },
	{ opname[NMT_SBC],ACT_RD | ADT_ABSX },
	{ opname[NMT_INC],ACT_WT | ADT_ABSX },
	{ opname[NMT_UND],ACT_NL | ADT_NONE }
};

memargstr mapper_mmc1_com[] = {
	{ 0x8000,0x9FFF,ACT_WT,(char*)"MMC1 Reg#0" },
	{ 0xA000,0xBFFF,ACT_WT,(char*)"MMC1 Reg#1" },
	{ 0xC000,0xDFFF,ACT_WT,(char*)"MMC1 P$1000 4K BnkSlct" },
	{ 0xE000,0xFFFF,ACT_WT,(char*)"MMC1 $8000 16K BnkSlct" },
	{ 0xFFFF,0x0000,ACT_NL,NULL },
};

memargstr mapper_unrom_com[] = {
//	{ 0x8000,0xFFFF,ACT_WT,(char*)"UNROM Select PRG-ROM Bank" },
	{ 0xFFFF,0x0000,ACT_NL,NULL },
};




#endif // __MD6502_H__
